select
	xid,
	starttime,
	endtime,
	endtime - starttime as duration,
	REGEXP_SUBSTR(querytxt, '"dbt_version": "([0-9.]+)"', 1, 1, 'e') as dbt_version, -- dbt version extracted from dbt comment
	REGEXP_SUBSTR(querytxt, '"node_id": "(\\w+)\\.jaffle_shop\\..*"', 1, 1, 'e')  as dbt_node_type, -- node type ("model" or "test") extracted from dbt comment
	REGEXP_SUBSTR(querytxt, '"node_id": ".+\\.jaffle_shop\\.(\\w+)\\.?(.*)"', 1, 1, 'e') as dbt_node_name, -- model or test name extracted from dbt comment
	LTRIM(REGEXP_REPLACE(TRIM(querytxt), '\\/\\*.*\\*\\/')) as querytxt -- query text without dbt comment
from stl_query
where 1=1
  --and starttime >= '2024-04-11'
  and REGEXP_SUBSTR(TRIM(querytxt), '"dbt_version": "([0-9.]+)"', 1, 1, 'e') <> '' -- filter out this query
  and LOWER(TRIM(querytxt)) like '%"dbt_version": "1.3.%"%"node_id": "%.jaffle_shop.%"%' -- filter queries from jaffle_shop project generated by dbt v1.3

union

select
	xid,
	starttime,
	endtime,
	duration,
	REGEXP_SUBSTR(text, '"dbt_version": "([0-9.]+)"', 1, 1, 'e') as dbt_version,
	REGEXP_SUBSTR(text, '"node_id": "(\\w+)\\.jaffle_shop\\..*"', 1, 1, 'e')  as dbt_node_type,
	REGEXP_SUBSTR(text, '"node_id": ".+\\.jaffle_shop\\.(\\w+)\\.?(.*)"', 1, 1, 'e') as dbt_node_name,
	LTRIM(REGEXP_REPLACE(TRIM(text), '\\/\\*.*\\*\\/')) as querytxt
from (
	select
		xid,
		starttime,
		endtime,
		endtime - starttime as duration,
		LISTAGG(case when LEN(RTRIM(text)) = 0 then text else REPLACE(RTRIM(text), '\\n', '') end) within group (order by sequence) as text
	from stl_ddltext
	where xid in (
		select xid
		from stl_ddltext
		where 1=1
		  --and starttime >= '2024-04-11'
		  and LOWER(TRIM(text)) like '%"dbt_version": "1.3.%"%"node_id": "%.jaffle_shop.%"%' -- filter queries from jaffle_shop project generated by dbt v1.3
	)
	group by xid, starttime, endtime 
)

order by starttime
